set ale_msg "This is the HPSG grammar from ALE 2.0. The ALE system\
	is developed by Bob Carpenter and Gerald Penn (CMU). The\
	HPSG grammar is written by the same authors"

button .t.version -text {Ale 2.0 HPSG} -command {
 tk_dialog .d "About the Grammar" $ale_msg "" 0 ok 
}
pack .t.version -side right

.menu.help.m add command -label "About the grammar" -underline 0\
               -command {
    tk_dialog .d "About the Grammar" $ale_msg "" 0 ok
}

catch {.menu.grammar.m delete 0 last}
.menu.grammar.m add command -label "Recompile HPSG grammar" \
  -command {
     prolog "compile_gram hpsg"
     prolog update_ale_flags
           } -underline 0
.menu.grammar.m add command -label "Reload HPSG grammar" \
  -command {
     prolog "consult hpsg"
     prolog freload
     prolog update_ale_flags
           } -underline 0

.menu.grammar.m add command -label "Compile grammar file"\
  -command {
       global fsBox
       FSBox {} {} {
           prolog "compile_gram $fsBox(path)/$fsBox(name)" 
           prolog update_ale_flags
       }       
}

# redefines Hdrug show menu completely
# showing objects available through obj buttons anyway..
catch {destroy .menu.show.m}    
menu .menu.show.m -postcommand {
    catch {.menu.show.m delete 0 last}
    prolog object_exists
    if $object_exists then {
	.menu.show.m add cascade -label Object -menu .menu.show.m.object
        .menu.show.m add command -label Edge -command {

    # chartlength is added in starthook!
    set leftpos 0
    set rightpos $chartlength
    catch {destroy .edge}
    toplevel .edge -class Dialog
    wm title .edge Edge
    wm iconname .edge Edge
    frame .edge.top
    frame .edge.mid
    frame .edge.bottom
    frame .edge.end
    pack .edge.top .edge.mid .edge.bottom .edge.end -pady 1m

    label .edge.top.label -text "Choose Edge Positions"
    pack .edge.top.label

    button .edge.mid.lleft -relief raised \
                  -bitmap @$hdrug_library/bitmaps/SP_left.bm -bd 4 -command {
        if {$leftpos > 0} {set leftpos [expr $leftpos - 1]}
    } 
    label .edge.mid.lmid -textvariable leftpos -width 2
    button .edge.mid.lright -relief raised \
                  -bitmap @$hdrug_library/bitmaps/SP_right.bm -bd 4 -command {
        if {$leftpos < $chartlength} {set leftpos [expr $leftpos + 1]}
    } 
    button .edge.mid.rleft -relief raised \
                  -bitmap @$hdrug_library/bitmaps/SP_left.bm -bd 4 -command {
        if {$rightpos > 0} {set rightpos [expr $rightpos - 1]}
    } 
    label .edge.mid.rmid -textvariable rightpos -width 2
    button .edge.mid.rright -relief raised \
                  -bitmap @$hdrug_library/bitmaps/SP_right.bm -bd 4 -command {
        if {$rightpos < $chartlength} {set rightpos [expr $rightpos + 1]}
    }
    pack .edge.mid.lleft .edge.mid.lmid .edge.mid.lright -side left -padx 1m
    pack .edge.mid.rright .edge.mid.rmid .edge.mid.rleft -side right -padx 1m
    button .edge.bottom.tk -text "Tk" -command {
	prolog "show_edge tk $leftpos $rightpos"
    }  -bg DarkSeaGreen2
    button .edge.bottom.ale -text "Ale" -command {
	prolog "show_edge ale $leftpos $rightpos"
    }  -bg DarkSeaGreen2
    button .edge.bottom.latex -text "Latex" -command {
	prolog "show_edge latex $leftpos $rightpos"
    } -bg DarkSeaGreen2
    button .edge.end.dismiss -text "Dismiss" -command {
    destroy .edge
    } -bg OrangeRed1
    pack .edge.bottom.tk .edge.bottom.ale .edge.bottom.latex -side left -padx 1m -pady 1m
    pack .edge.end.dismiss -padx 1m -pady 1m
    }
    }
    if { "$ale(lexs)" != ""} then {
	.menu.show.m add cascade -label "View Lexical Entry" \
                            -menu .menu.show.m.lex
    }
    if { "$ale(macros)" != ""} then {
	.menu.show.m add cascade -label "View Macro" \
                            -menu .menu.show.m.macro
    }
    if { "$ale(rules)" != ""} then {
	.menu.show.m add cascade -label "View Rules" \
                            -menu .menu.show.m.rule
    }
    if { "$ale(lex_rules)" != ""} then {
	.menu.show.m add cascade -label "View Lexical Rule" \
                            -menu .menu.show.m.lex_rule
    }
    if { "$ale(types)" != ""} then {
	.menu.show.m add cascade -label "View Type" \
                            -menu .menu.show.m.type
    }
    if $ale(empty) then {
	.menu.show.m add cascade -label "View Empty Categories" \
                            -menu .menu.show.m.empty
    }
    if { "$ale(clauses)" != ""} then {
	.menu.show.m add cascade -label "View Clause" \
                            -menu .menu.show.m.clause
    }
}

menu .menu.show.m.lex
.menu.show.m.lex add command -label "Tk" \
	-command "show_it tk lexs"
.menu.show.m.lex add command -label "Ale" \
	-command "show_it ale lexs"
.menu.show.m.lex add command -label "Latex" \
	-command "show_it latex lexs"

menu .menu.show.m.object
.menu.show.m.object add command -label "Tk" \
	-command {
        set obj [SP_select_obj]
        if {$obj == 0} {return 0}
	prolog "show_it tk object $obj"
}
.menu.show.m.object add command -label "Ale" \
	-command {
        set obj [SP_select_obj]
        if {$obj == 0} {return 0}
	prolog "show_it ale object $obj"
}

.menu.show.m.object add command -label "Latex" \
	-command {
        set obj [SP_select_obj]
        if {$obj == 0} {return 0}
	prolog "show_it latex object $obj"
}

menu .menu.show.m.macro
.menu.show.m.macro add command -label "Ale" \
	-command "show_it ale macros"
menu .menu.show.m.rule
.menu.show.m.rule add command -label "Ale" \
	-command "show_it ale rules"
menu .menu.show.m.lex_rule
.menu.show.m.lex_rule add command -label "Ale" \
        -command "show_it ale lex_rules"
menu .menu.show.m.type
.menu.show.m.type add command -label "Ale" \
	-command "show_it ale types"
menu .menu.show.m.empty
.menu.show.m.empty add command -label "Ale" \
	-command "prolog empty"
menu .menu.show.m.clause
.menu.show.m.clause add command -label "Ale" \
        -command "show_it ale clauses"


proc show_it {output type} {
    global ale
    set thing [SP_qlist .w $ale($type) $type "Show $type" ]
    if {$thing == 0} {return 0}
    prolog "show_it $output $type $thing"
}

# overwrite this from SP_hdrug.tcl...
proc SP_object {no} {
    # should not be necc:
    catch "destroy .bb.obj$no"

    menubutton .bb.obj$no -menu .bb.obj$no.a -text "$no" -bg yellow -relief raised
    pack .bb.obj$no -side left
    menu .bb.obj$no.a
    .bb.obj$no.a add cascade -label "View" \
	            -menu .bb.obj$no.a.show
    menu .bb.obj$no.a.show
    .bb.obj$no.a.show add command -label "Tk" \
		-command "prolog_show_it tk object $no"
      .bb.obj$no.a.show add cascade -label "Ale" \
        -menu .bb.obj$no.a.show.prolog
      menu .bb.obj$no.a.show.prolog
      catch {.bb.obj$no.a.show.prolog delete 0 last}
      .bb.obj$no.a.show.prolog add command -label Semantics \
                -command "SP_show_object_prolog_semantics $no"
      .bb.obj$no.a.show.prolog add command -label Matrix \
                -command "SP_show_object_prolog_text $no"
      
      .bb.obj$no.a.show add command -label "LaTeX" \
		-command "prolog_show_it latex object $no"
    update
}

# put objects in ObjectBar if they already exist
set i 1
while {$i < $objs} {
        SP_object $i
        incr i +1
}
unset i

proc prolog_show_it {a b c} {
    prolog "show_it $a $b $c"
}
