button .t.version -text {Recursive Lexical Rules} -command {
    tk_dialog .d "About the Grammar" "
        This grammar is written by G. van Noord. It is a \
        head-driven unification grammar for Dutch in which\
        powerful recursive lexical rules are used. The\
        approach is desribed in the paper `The Scope of Adjuncts and the\
        Processing of Lexical Rules', co-authored with Gosse\
        Bouma, which appears in the Proceedings of Coling\
        1994, Kyoto." "" 0 ok
}

pack .t.version -side right

prolog {send_boolean_flag add_mod}
prolog {send_boolean_flag push_to_slash}
prolog {send_boolean_flag push_to_extra}

.menu.grammar.m add cascade -label "Change Flags" -menu .menu.grammar.flag

menu .menu.grammar.flag
.menu.grammar.flag add check -label add_mod\
      -variable flag(add_mod)\
     -command "change_boolean_flag add_mod"

.menu.grammar.flag add check -label push_to_slash \
     -variable flag(push_to_slash)\
     -command "change_boolean_flag push_to_slash"

.menu.grammar.flag add check -label push_to_extra \
     -variable flag(push_to_extra)\
     -command "change_boolean_flag push_to_extra"

.menu.grammar.m add cascade -label "View Lexical Hierarchy"\
	-menu .menu.grammar.lh

.menu.grammar.m add cascade -label "View Part of Hierarchy"\
	-menu .menu.grammar.lhp

menu .menu.grammar.lh

.menu.grammar.lh add command -label "Tk" -command {
    prolog call_tree_bu_tk
}
.menu.grammar.lh add command -label "Tex" -command {
    prolog call_tree_bu_latex
}
.menu.grammar.lh add command -label "Prolog" -command {
    prolog call_tree_bu
}

menu .menu.grammar.lhp

.menu.grammar.lhp add command -label "Tk" -command {
    prolog "ct tk \
               [SP_qlist .w $unary_preds {Lexical Type} {Lexical Type}]"
}
.menu.grammar.lhp add command -label "Tex" -command {
    prolog "ct latex \
               [SP_qlist .w $unary_preds {Lexical Type} {Lexical Type}]"
}
.menu.grammar.lhp add command -label "Prolog" -command {
    prolog "ct prolog \
               [SP_qlist .w $unary_preds {Lexical Type} {Lexical Type}]"
}


#proc SP_call_tree {} {
#      prolog "call_tree_bu_tk [SP_question .w "Lexical Type" \
#         "Lexical Type to show" {}]"
#}

.menu.help.m add command -label "About the grammar" -underline 0\
               -command {
    tk_dialog .d "About the Grammar" "
	This grammar is written by G. van Noord. It is a \
	head-driven unification grammar for Dutch in which\
	powerful recursive lexical rules are used. The\
	approach is desribed in the paper `The Scope of Adjuncts and the\
	Processing of Lexical Rules', co-authored with Gosse\
	Bouma, which appears in the Proceedings of Coling\
	1994, Kyoto." "" 0 ok
}

set stems {}
prolog stem_exists

if $stem_exists then {
        .menu.grammar.m add cascade -label "View Lexical Entry" -menu .menu.grammar.m.stem
}

menu .menu.grammar.m.stem
.menu.grammar.m.stem add cascade -label "Prolog" -menu .menu.grammar.m.stem.prolog
.menu.grammar.m.stem add cascade -label "LaTeX"  -menu .menu.grammar.m.stem.latex

menu .menu.grammar.m.stem.latex
.menu.grammar.m.stem.latex add command -label "Text" \
      -command show_stem_latex_text

if $type_exists then {
    .menu.grammar.m.stem.latex add command -label "Matrix" \
          -command show_stem_latex_matrix
}

menu .menu.grammar.m.stem.prolog
.menu.grammar.m.stem.prolog add command -label "Text" \
      -command show_stem_prolog_text
if $type_exists then {
    .menu.grammar.m.stem.prolog add command -label "Matrix" \
          -command show_stem_prolog_matrix
}

proc show_stem_prolog_text {} {
    global stems
    set stem [SP_qlist .w $stems Stem "Stem to show" ]
    if {$stem == 0} {return 0}
    prolog "show_stem_prolog_text $stem"
}

### matrix
proc show_stem_prolog_matrix {} {
    global stems
    set stem [SP_qlist .w $stems Stem "Stem to show:" ]
    if {$stem == 0} {return 0}
    prolog "show_stem_prolog_matrix $stem"
}

## latex
### text
proc show_stem_latex_text {} {
    global stems
    set stem [SP_qlist .w $stems Stem "Stem to show:" ]
    if {$stem == 0} {return 0}
    prolog "show_stem_latex_text $stem"
}

### matrix
proc show_stem_latex_matrix {} {
    global stems
    set stem [SP_qlist .w $stems Stem "Stem to show:" ]
    if {$stem == 0} {return 0}
    prolog "show_stem_latex_matrix $stem"
}


proc change_boolean_flag {kind} {
    global flag
    prolog "receive_boolean_flag $kind $flag($kind)"
}

