
set fs_started 0

proc start_fs {w} {
  global fs_started
  global hdrug_library
  if !$fs_started {
  toplevel $w -class Dialog
  wm minsize $w 0 0
  wm title $w Matrix
  wm iconname $w Matrix
  wm iconbitmap $w @$hdrug_library/bitmaps/hdrug.xbm
  option add *fs*attl*Font \
	-adobe-helvetica-medium-o-normal--*-120-*-*-*-*-iso8859-* 100
  option add *fs*v_a_ll*Font \
	-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-iso8859-* 100
  option add *fs*varl*Font \
	-adobe-helvetica-bold-r-normal--*-120-*-*-*-*-iso8859-* 100
  option add *fs*typel*Font \
	-adobe-helvetica-bold-o-normal--*-120-*-*-*-*-iso8859-* 100

  option add *fs*v_a_l.BorderWidth 4 
  option add *fs*v_a_l.Relief ridge
#  option add *fs*val*BorderWidth 4 
#  option add *fs*val*Relief ridge
#  option add *fs.f.BorderWidth 4
#  option add *fs.f.Relief ridge

  scrollbar $w.sx -relief sunken -orient horiz -command "$w.fs xview"
  scrollbar $w.sy -relief sunken               -command "$w.fs yview"
  button $w.b -text OK -command "destroy $w ; set fs_started 0"

  pack $w.b -side bottom
  pack $w.sx -side bottom -fill x
  pack $w.sy -side right -fill y

  set fs_started 1
  canvas $w.fs -yscroll "$w.sy set" \
               -xscroll "$w.sx set" \
               -scrollregion {0 0 200c 200c} -width 500 -height 400
  pack $w.fs -fill both -expand 1

  ## the canvas can also be `scrolled' by dragging 2nd mouse button
  bind $w.fs <2> "$w.fs scan mark %x %y"
  bind $w.fs <B2-Motion> "$w.fs scan dragto %x %y"
  ## the large canvas is cleared with third mouse button
  bind $w.fs <3> "destroy $w ; set fs_started 0"
  }
  catch {destroy $w.fs.f}
  frame $w.fs.f
  $w.fs create window 10 10 -window $w.fs.f -anchor nw
  return $w.fs.f
}

proc fs_example {w} {
 set m [start_fs $w]

 frame $m.v_a_l
 pack $m.v_a_l

 label $m.v_a_l.typel -text NP
 frame $m.v_a_l.a
 frame $m.v_a_l.b
 frame $m.v_a_l.c
 pack $m.v_a_l.typel $m.v_a_l.a $m.v_a_l.b $m.v_a_l.c -anchor w 

 label $m.v_a_l.a.attl -text a: 
 frame $m.v_a_l.a.v_a_l 
 pack $m.v_a_l.a.attl $m.v_a_l.a.v_a_l -side left

 label $m.v_a_l.b.attl -text b: 
 label $m.v_a_l.b.v_a_ll -text g 
 pack $m.v_a_l.b.attl $m.v_a_l.b.v_a_ll -side left

 label $m.v_a_l.a.v_a_l.typel -text VP
 frame $m.v_a_l.a.v_a_l.c
 frame $m.v_a_l.a.v_a_l.e
 pack $m.v_a_l.a.v_a_l.typel $m.v_a_l.a.v_a_l.c $m.v_a_l.a.v_a_l.e

 label $m.v_a_l.a.v_a_l.c.attl -text c: 
 label $m.v_a_l.a.v_a_l.c.v_a_ll -text d  
 pack $m.v_a_l.a.v_a_l.c.attl $m.v_a_l.a.v_a_l.c.v_a_ll -side left
 
 label $m.v_a_l.a.v_a_l.e.v_a_ll -text f 
 label $m.v_a_l.a.v_a_l.e.attl -text e: 
 pack $m.v_a_l.a.v_a_l.e.attl $m.v_a_l.a.v_a_l.e.v_a_ll -side left
 
 label $m.v_a_l.c.attl -text c: 
 frame $m.v_a_l.c.v_a_l 
 pack $m.v_a_l.c.attl $m.v_a_l.c.v_a_l -side left

 label $m.v_a_l.c.v_a_l.typel -text S 
 frame $m.v_a_l.c.v_a_l.a 
 frame $m.v_a_l.c.v_a_l.b
 pack $m.v_a_l.c.v_a_l.typel $m.v_a_l.c.v_a_l.a $m.v_a_l.c.v_a_l.b -anchor w
 
 label $m.v_a_l.c.v_a_l.a.attl -text a: 
 label $m.v_a_l.c.v_a_l.a.varl -text X 
 pack $m.v_a_l.c.v_a_l.a.attl $m.v_a_l.c.v_a_l.a.varl -side left
 
 label $m.v_a_l.c.v_a_l.b.attl -text b: 
 frame $m.v_a_l.c.v_a_l.b.v_a_l 
 pack $m.v_a_l.c.v_a_l.b.attl $m.v_a_l.c.v_a_l.b.v_a_l -side left
 
 label $m.v_a_l.c.v_a_l.b.v_a_l.typel -text SBAR
 frame $m.v_a_l.c.v_a_l.b.v_a_l.a
 pack $m.v_a_l.c.v_a_l.b.v_a_l.typel $m.v_a_l.c.v_a_l.b.v_a_l.a

 label $m.v_a_l.c.v_a_l.b.v_a_l.a.attl -text d:
 label $m.v_a_l.c.v_a_l.b.v_a_l.a.varl -text X
 pack $m.v_a_l.c.v_a_l.b.v_a_l.a.attl $m.v_a_l.c.v_a_l.b.v_a_l.a.varl -side left
}



