proc SP_more {} {
	set default 1
	set args "No Yes"
    global SP_more_answer
    global hdrug_library

    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    catch {destroy .dw}
    toplevel .dw -class Dialog
    wm iconbitmap .dw @$hdrug_library/bitmaps/hdrug.xbm
    wm title .dw more
    wm iconname .dw Dialog
    frame .dw.top -relief raised -bd 1
    pack .dw.top -side top -fill both
    frame .dw.bot -relief raised -bd 1
    pack .dw.bot -side bottom -fill both

    # 2. Fill the top part with bitmap and message.

    message .dw.msg -width 3i -text "More?" \
	    -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack .dw.msg -in .dw.top -side right -expand 1 -fill both -padx 5m -pady 5m

    # 3. Create a row of buttons at the bottom of the dialog.

    set i 0
    foreach but $args {
	button .dw.button$i -text $but -command "set SP_more_answer $i"
	if {$i == $default} {
	    frame .dw.default -relief sunken -bd 1
	    raise .dw.button$i .dw.default
	    pack .dw.default -in .dw.bot -side left -expand 1 -padx 3m -pady 2m
	    pack .dw.button$i -in .dw.default -padx 2m -pady 2m \
		    -ipadx 2m -ipady 1m
	    bind .dw <Return> ".dw.button$i flash; set SP_more_answer $i"
	} else {
	    pack .dw.button$i -in .dw.bot -side left -expand 1 \
		    -padx 3m -pady 3m -ipadx 2m -ipady 1m
	}
	incr i
    }

    # 4. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then center the window in the
    # display and de-iconify it.

    wm withdraw .dw
    update idletasks
    set x [expr [winfo screenwidth .dw]/2 - [winfo reqwidth .dw]/2 \
	    - [winfo vrootx [winfo parent .dw]]]
    set y [expr [winfo screenheight .dw]/2 - [winfo reqheight .dw]/2 \
	    - [winfo vrooty [winfo parent .dw]]]
    wm geom .dw +$x+$y
    wm deiconify .dw

    # 5. Set a grab and claim the focus too.

#    set oldFocus [focus]
#    grab .dw
#    focus .dw

    # 6. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    tkwait variable SP_more_answer
    destroy .dw
#    focus $oldFocus
    prolog "receive_boolean_flag proceed $SP_more_answer"
}

proc SP_sub_more {win} {
	set default 1
	set args "No Yes"
    global SP_more_answer

    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    catch {destroy $win}
    frame $win
    pack $win
    frame $win.top -relief raised -bd 1
    pack $win.top -side top -fill both
    frame $win.bot -relief raised -bd 1
    pack $win.bot -side bottom -fill both

    # 2. Fill the top part with bitmap and message.

    label $win.msg -text "More?" \
	    -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack $win.msg -in $win.top -side right -expand 1 -fill both -padx 1m -pady 1m

    # 3. Create a row of buttons at the bottom of the dialog.

    set i 0
    foreach but $args {
	button $win.button$i -text $but -command "set SP_more_answer $i"
	if {$i == $default} {
	    frame $win.default -relief sunken -bd 1
	    raise $win.button$i $win.default
	    pack $win.default -in $win.bot -side left -expand 1 -padx 3m -pady 2m
	    pack $win.button$i -in $win.default -padx 2m -pady 2m \
		    -ipadx 2m -ipady 1m
	    bind $win <Return> "$win.button$i flash; set SP_more_answer $i"
	} else {
	    pack $win.button$i -in $win.bot -side left -expand 1 \
		    -padx 3m -pady 3m -ipadx 2m -ipady 1m
	}
	incr i
    }

    # 6. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    tkwait variable SP_more_answer
    destroy $win
    prolog "receive_boolean_flag proceed $SP_more_answer"
}





