# SP_question   based on dialog
# 
# Arguments:
# w -		Window to use for dialog top-level.
# title -	Title to display in dialog's decorative frame.
# text -	Message to display in dialog.
# bitmap -	Bitmap to display in dialog (empty string means none).

proc SP_question {w title text bitmap} {
    global tk_priv
    global answer
    global hdrug_library

    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    set answer {}
    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Question
    wm iconbitmap $w @$hdrug_library/bitmaps/hdrug.xbm
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    entry $w.mid -relief sunken -bd 1 -textvariable answer
    pack $w.mid -side top -padx 3m -fill both
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both

    bind $w.mid <Return> {set tk_priv(button) 0}
	# return is the same as ok   

    # 2. Fill the top part with bitmap and message.

    message $w.msg -width 3i -text $text \
	    -font -Adobe-Times-Medium-R-Normal-*-180-*
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 5m -pady 5m
    if {$bitmap != ""} {
	label $w.bitmap -bitmap $bitmap
	pack $w.bitmap -in $w.top -side left -padx 5m -pady 5m
    }

    # 3. Create a row of buttons at the bottom of the dialog.

    set args {ok cancel}
    set default 0
    set i 0
    foreach but $args {
	button $w.button$i -text $but -command "set tk_priv(button) $i"
	if {$i == $default} {
	    frame $w.default -relief sunken -bd 1
	    raise $w.button$i $w.default
	    pack $w.default -in $w.bot -side left -expand 1 -padx 3m -pady 2m
	    pack $w.button$i -in $w.default -padx 2m -pady 2m \
		    -ipadx 2m -ipady 1m
	    bind $w <Return> "$w.button$i flash; set tk_priv(button) $i"
	} else {
	    pack $w.button$i -in $w.bot -side left -expand 1 \
		    -padx 3m -pady 3m -ipadx 2m -ipady 1m
	}
	incr i
    }

    # 4. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then center the window in the
    # display and de-iconify it.

    wm withdraw $w
    update idletasks
    set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	    - [winfo vrootx [winfo parent $w]]]
    set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	    - [winfo vrooty [winfo parent $w]]]
    wm geom $w +$x+$y
    wm deiconify $w

    # 5. Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w
    focus $w

    # 6. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    tkwait variable tk_priv(button)
    destroy $w
    focus $oldFocus
#    return $tk_priv(button)
    if {$tk_priv(button) == 1} {return 0} 
    if {$tk_priv(button) == 0} {return $answer}
}


