proc SP_send_sent {} {
    global sents
    set sent [SP_qbox .p sents Question "         Select a Sentence         "]
    if {$sent == 0} {return 0}
    prolog start_sent
    foreach i $sent {
       prolog "next_word $i"
    }
    update
    return 1
}

proc SP_select_obj {} {
    global flag
    prolog {send_flag current_no}
    if {$flag(current_no) == 1} {return 0}
    if {$flag(current_no) == 2} {return 1}
    set i 1
    set j {tk_dialog .d Select Object {} 1 cancel}
    while {$i < $flag(current_no)} {
          lappend j $i
          incr i
    }
    return [eval $j]
}

proc SP_change_parser {prs} {
	global parser
	prolog "change_pm $parser($prs) $prs parser_mode"
}
 
proc SP_change_generator {prs} {
    global generator
    prolog "change_pm $generator($prs) $prs generator_mode"
}

# show objects
## canvas
proc show_object_canvas_tree {type} {
    set obj [SP_select_obj]
    if {$obj == 0} {return 0}
    prolog "show_object_canvas_tree $type $obj"
}

## prolog
### tree
proc show_object_prolog_tree {type} {
    set obj [SP_select_obj]
    if {$obj == 0} {return 0}
    prolog "show_object_prolog_tree $type $obj"
}

## latex
### tree
proc show_object_latex_tree {type} {
    set obj [SP_select_obj]
    if {$obj == 0} {return 0}
    prolog "show_object_latex_tree $type $obj"
}

proc SP_delete_objects {i} {
     while {$i > 1} {
     incr i -1
     catch "destroy .bb.obj$i"
    }
	update
}

proc SP_receive_flag {att val} {
	global flag
	set flag($att) $val
	prolog "receive_flag $att $val"
}

proc SP_show_object_canvas_tree {i no} {
	prolog "show_object_canvas_tree $i $no"
}

proc SP_show_object_prolog_tree {i no} {
	prolog "show_object_prolog_tree $i $no"
}

proc SP_show_object_prolog_semantics {no} {
	prolog "show_object_prolog_semantics $no"
}

proc SP_show_object_prolog_matrix {no} {
	prolog "show_object_prolog_matrix $no"
}

proc SP_show_object_prolog_text {no} {
	prolog "show_object_prolog_text $no"
}

proc SP_show_object_latex_tree {i no} {
	prolog "show_object_latex_tree $i $no"
}

proc SP_show_object_latex_matrix {no} {
	prolog "show_object_latex_matrix $no"
}

proc SP_show_object_latex_text {no} {
	prolog "show_object_latex_text $no"
}

proc SP_show_object_latex_semantics {no} {
    prolog "show_object_latex_semantics $no"
}

proc SP_generate_object {no} {
	prolog "generate_object $no"
}

proc SP_generate_object_comp {no} {
	prolog "generate_object_comp $no"
}

